; edomer.asm, peridusid vltozat, RA0 kimeneten kalibrlshoz 16 MHz

	list		p=16f1704      ; list directive to define processor
	list		r=dec
	#include	<p16f1704.inc> ; processor specific variable definitions

	__CONFIG _CONFIG1, _FOSC_HS & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF  & _BOREN_ON & _CLKOUTEN_OFF & _IESO_OFF  & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_OFF & _BORV_LO & _LVP_OFF
	
; Vltozk
	cblock	0x20
	lcb1:16
	lcb2:16
	dec2
	dec1
	dec0
	ENDC
	cblock	0x70	; megvan a 16
	flags	; jelzbitek
	f1	; jelzbitek
	au
	ah
	al
	bh
	bl
	ch
	cl
	aux
	t2popo	; timer2 ut-utoszt
	LCD
	posi
	index
	count
	chars
	endc
;aliasok
#define	newt1	flags,7	; j t1 adat van
#define flag	flags,6	; LCD RS flag
#define nlead	flags,5	; nem kezd karakter
#define t2exp	flags,4	; holtid lejrt
#define	car	flags,3	; aritmetika segdbitje
#define	polar	flags,2	; t1g kivnt polaritsa
#define	err	flags,1	; timer1 tl-tlcsorduls

#define	toggle	f1,7	; gate toggle mode
#define	range	f1,6	; mrsi tartomny

; kt jumpernek egyelre nincs szerepe
#define jp03	porta,0	
#define	jp02	portc,5
#define	jp01	portc,4	; gate polarity

#define	rs	lata,1
#define	e	lata,2

line1	equ	80h
line2	equ	0c0h
baux	equ	posi

; makrk
	#include <prlx.inc>

tim1ini	macro	; timer1 mg lldogl
	banksel	t1con
	movlw	44h	; frge md
	snb	range
	movlw	34h	; lusta md, range=1
	movwf	t1con
	movlw	0b0h
	sb	toggle
	movlw	90h
	movwf	t1gcon	; gate toggle mode
	sb	polar
	bcf	t1gcon,t1gpol
	snb	polar
	bsf	t1gcon,t1gpol
	clrf	tmr1h
	clrf	tmr1l
	bcf	pir1,tmr1if
	endm
tim1disable	macro
	banksel	t1con
	bcf	t1con,tmr1on
	endm
tim1enable	macro
	banksel	t1con
	bsf	t1con,tmr1on
	endm
tim1rst	macro	; timer1 trls (a megszaktst kln kell)
	banksel	t1con
	clrf	tmr1h
	clrf	tmr1l
	endm
tim2ini	macro	; timer2 incializls 10 ms-ra, nem indt 
	banksel	t2con
	movl	t2con,23h	; minden oszt benne
	movl	pr2,249
	clrf	tmr2
	banksel	pir1
	bcf	pir1,tmr2if
	endm
tim2rst	macro	; timer2 lellts, trls, a megszaktst is
	banksel	t2con
	bcf	t2con,tmr2on
	clrf	tmr2
	banksel	pir1
	bcf	pir1,tmr2if
	endm
tim2go	macro	; timer2indts s semmi ms
	banksel	t2con
	bsf	t2con,tmr2on
	endm
oscini	macro	; 16 MHz bels, semmi extra
	banksel	osccon
	movl	osccon,70h
	clrf	oscstat
	clrf	osctune
	endm
getmode	macro
	banksel	porta
	sb	portc,5
	bcf	toggle
	snb	portc,5
	bsf	toggle
	endm
getpol	macro
	banksel	porta
	sb	portc,4
	bcf	polar
	snb	portc,4
	bsf	polar
	endm
	
stc	macro
	bsf	status,c
	endm
; program
	org	0
	nop
	pagesel	start
	goto	start
; megszaktsok: timer1 kapuzrs, timer2 peridus (10 ms), 
; timer1 tlcsorduls	
	org	4
	; timer1 kapuzrs (a program hurokban vr r)
	banksel	pir1
	jnb	pir1,tmr1gif,sk1
	bsf	newt1		; a kapuzrs jelzi a megtrtntt
	bcf	pir1,tmr1gif
sk1	; timer2 peridus (a program hurokban vr r)
	sb	pir1,tmr2if
	goto	sk2
	bcf	pir1,tmr2if
	bsf	t2exp		; a timer2 peridus is
sk2	; timer1 tlcsorduls (az eredmny a kapuzrs utn kell)
	sb	pir1,tmr1if
	retfie
	bcf	pir1,tmr1if
	incf	ah,f		; inkrementlja a szmllbvtt
	snb	ah,5
	bsf	err		; s tllpsnl hibajelzst ad 
	retfie

; fprogram, az alkalomhoz ill inicializlssal
start
	banksel	lata
	clrf	lata
	clrf	latc
	banksel	trisa
	movl	trisa,38h
	movl	trisc,30h
	bcf	option_reg,7
	bcf	option_reg,tmr0cs
	banksel	ansela
	clrf	ansela
	clrf	anselc
	banksel	wpua
	movl	wpua,8	; tmenetileg a bemenetre is
	movl	wpuc,30h
	banksel	ra0pps
	movlw	4
	movwf	ra0pps
	banksel	t1gpps
	movlw	3	; ra3 a bemenet
	movwf	t1gpps
	#include tune.inc
	getmode
	tim1ini
	tim2ini
	clrf	flags
	clrf	f1
	banksel	0
	clrf	fsr0h
	clrf	fsr1h
	call	ldelay
	call	dini	
	call	prep1	; kijelz maszk	
	call	prep2
	movl	t2popo,20
	tim1enable	; engedlyezve, de mg nem hatsos a kapu	
; lehet engedlyezni a megszaktst, de melyiket is? Ezt a hrmat!
	banksel	pie1
	bsf	pie1,tmr1gie
	bsf	pie1,tmr1ie
	bsf	pie1,tmr2ie
	banksel	0
	bsf	intcon,peie
	bsf	intcon,gie
; most jn a hurok,kis szerencsvel nem a nyakam kr
main
	banksel	porta
	clrf	au
	clrf	ah
	bcf	err
	bcf	intcon,gie
	banksel	t1gcon
	bcf	newt1
	bsf	t1gcon,t1ggo_not_done
	bsf	intcon,gie	
lp1
	jnb	newt1,lp1	; itt vr a kapuzrsra
	jb	range,long	; paramtertvtel eltt elgazik!
	banksel	tmr1h
	clrf	au
	mov	al,tmr1h	; ktbjtos eredmny
	mov	aux,tmr1l	; mentse al:aux-ba
	rlf	aux,f		; a trtrsz ellltsa aux-ban,
	rlf	al,f		; az egsz pedig ah:al-ben
	rlf	ah,f
	rlf	aux,f
	rlf	al,f
	rlf	ah,f
	rlf	aux,f
	rlf	al,f
	rlf	ah,f
	rrf	aux,f
	rrf	aux,f
	rrf	aux,f
	movlw	31
	andwf	aux,f
	banksel	0
	call	bdaux		; aux konvertlsa
	movl	fsr0l,dec0
	movl	fsr1l,lcb1+8
	movl	count,1
	call	expandbcd
	call	delay
	call	bibcd16 	; ah:al konvertlsa
	movl	fsr0l,bl
	movl	fsr1l,lcb1+1
	movl	count,3
	call	expandbcd
	call	out1
	snb	err
	bsf	range
	goto	common
; ez a msodik g
long
	banksel	tmr1h
	mov	au,ah
	mov	ah,tmr1h
	mov	al,tmr1l
	banksel	0
	bcf	range
	movf	au,f
	sz
	bsf	range
	snb	ah,7
	bsf	range	; eddig nem lehet baj
	call	bibc24
	movl	fsr0l,bh
	movl	fsr1l,lcb2+5
	movl	count,4
	call	expandbcd
	call	out2
common	
	snb	err
	call	hiba	
	bcf	err		; hibabit trlse
	movl	t2popo,20	; t2 ut-utoszt jratltse
	tim2go			; indul a 200 ms vrakozs
lp2
; ide lehetne beszrni gombkezelst s hasonlkat, ami befr
; 10 ms-ba, de most mg csak egy polaritsvltsi lehetsg
; kerlt ide. Ebben a szakaszban tmr1 ll, s nem indul el, 
; amg nem rgok a go bitjbe, teht btran csereberlhetem 
; a bemenet polaritst,de ha ezzel netn timer1 gate esemnyt
; okoznk, a megszaktskrst trlni kell. Emiatt a kezels 
; tiltott megszakts mellett hajtdik vgre.
	banksel	t1con
	tim1disable
	getmode 	; beszedi a toggle bitet
	getpol
skset
	nop
	jnb	t2exp,lp2
	bcf	t2exp
	djnz	t2popo,lp2
	banksel	porta
	bcf	intcon,gie
	tim1ini
	banksel	0
	bcf	pir1,tmr1gif
	bcf	pir1,tmr1if
	bsf	intcon,gie
	tim2rst
	tim1enable

	goto	main

hiba
	movl	posi,line1	; a hibajelzs kezelse:
	call	dpos		; j pozci: els sor eleje
	movlw	20h
	snb	err
	movl	lcd,"E"		; van hiba: E
	goto	dlcd		; kirsa az aktulis pozcira

	#include <lcd.inc>
	#include <conv.inc>
	end	
	 